<!-- using firebase phone auth  -->

<div class="row">
  <div class="col-sm-5">
    <div class="card" style="margin: 20px">
      <div class="card card-header">
        <div class="row">
          <h3>Sign with your phone number</h3>
        </div>
      </div>
      <div class="card card-body">
        <form>
          <div class="form-group">
            <label for="phoneNumber">Phone Number</label> <br>
            <input class="form-control" type="text" id="phoneNumber" name="phoneNumber" />
          </div>
          <br>
          <div class="form-group" id="recaptcha-container"></div> <br>
          <button type="button" class="btn" id="sendCodeBtn">Send Code</button>
        </form>
      </div>
    </div>
  </div>
  <div class="col-sm-5">
    <div class="card" style="margin: 20px">
      <div class="card card-header">
        <div class="row">
          <h3>Register with </h3>
        </div>
      </div>
      <div class="card card-body">
        <form id="form-register" action="/user/register" method="POST">
          <div class="form-group">
            <label for="code">Code</label>
            <input class="form-control" type="text" id="code" name="code" />
          </div>
            <input class="form-control" type="text" id="phoneNumberSignIn" name="phone" hidden/>
            <input class="form-control" type="text" id="uid" name="uid" hidden/>
          <div class="form-group">
            <label for="code">Name</label>
            <input class="form-control" type="text" name="name" />
          </div>
          <div class="form-group">
            <label for="code">Password</label>
            <input class="form-control" type="text" name="password" />
          </div>
          <div class="form-group">
            <label for="code">Email</label>
            <input class="form-control" type="text" name="email" />
          </div>
          <div class="form-group">
            <label for="code">Address</label>
            <input class="form-control" type="text"  name="address" />
          </div>
          <div class="form-group">
            <label for="code">Birthday</label>
            <input class="form-control" type="text" name="birthday" />
          </div>
          <div class="form-group">
            <label for="code">Gender</label>
            <select name="gender">
              <option value="male">Male</option>
              <option value="female">Female</option>
            </select>
          </div>
          <button type="button" class="btn" id="signInBtn">Register</button>
        </form>
      </div>
    </div>
  </div>
</div>

<script src="https://www.gstatic.com/firebasejs/8.1.1/firebase-app.js"></script>

<script src="https://www.gstatic.com/firebasejs/8.1.1/firebase-auth.js"></script>

<script>

  var firebaseConfig = {
    apiKey: "AIzaSyAkuF5cqWxdu5Xa6Nb2Vs5IgPG2G29Et4A",
    authDomain: "auth-test-p.firebaseapp.com",
    databaseURL: "https://auth-test-p.firebaseio.com",
    projectId: "auth-test-p",
    storageBucket: "auth-test-p.appspot.com",
    messagingSenderId: "3020675102",
    appId: "1:3020675102:web:835bab3f313a5834a6b60f",
    measurementId: "G-J7N039YL9N"
  };

  // Initialize Firebase
  firebase.initializeApp(firebaseConfig);

  window.onload = function () {
    window.recaptchaVerifier = new firebase.auth.RecaptchaVerifier('recaptcha-container');
    recaptchaVerifier.render();
  }


  const sendVerificationCode = async () => {
    let phoneNumber = document.getElementById('phoneNumber').value;
    fetch('/user/check-phone', {
      method: 'POST',
      headers: {
        Accept: "application/json",
        "Content-Type": "application/json"
      },
      body: JSON.stringify({
        phone: phoneNumber
      })
    })
      .then(response => response.json())
      .then(data => {
        if (data.status !== 'exist') {
          console.log(phoneNumber);
          firebase.auth().signInWithPhoneNumber(phoneNumber, window.recaptchaVerifier)
            .then(function (confirmationResult) {
              // SMS sent. Prompt user to type the code from the message, then sign the
              // user in with confirmationResult.confirm(code).
              window.confirmationResult = confirmationResult;
              console.log(confirmationResult);
              alert('code sended');
              const verificationId = confirmationResult.verificationId;
              console.log(verificationId);
              document.getElementById('signInBtn').addEventListener('click', signInWithPhone);
            }).catch(function (error) {
              console.log(error);
            });
        } else {
          alert('Phone is exist!!!');
        }
      });
  }
  const signInWithPhone = () => {
    const code = document.getElementById('code').value;
    confirmationResult.confirm(code).then(function (result) {
      console.log(result.user);
      document.getElementById('phoneNumberSignIn').value = result.user.phoneNumber;
      document.getElementById('uid').value = result.user.uid;
      document.getElementById('form-register').submit();
      // ...
    }).catch(function (error) {
      // User couldn't sign in (bad verification code?)
      // ...
      alert(error);
      console.log(error);
    });
  }
  document.getElementById('sendCodeBtn').addEventListener('click', sendVerificationCode);
</script>